subroutine FM28(Fun, X, H, Alpha, Beta, Gamma, Eps)
!   f(x1,x2,...,xn)  -
interface
  real function Fun(x)
    real, intent(in):: X(:)
  end function Fun
end interface
real, intent(in):: H, Alpha, Beta, Gamma, Eps
real, intent(inout):: X(:)
integer, parameter:: CCmax=1000
real, allocatable:: S(:,:), XH(:), XG(:),  &
     XL(:), XO(:), XR(:), XC(:), XE(:), F(:)
real Z, FO, FL, FG, FH, FC, FE, FR, Sum1, Sum2
real ME2, SQME, EE, Xmin, Rmax, Sigma
integer i, j, n, n1, jg, jh, jl, CC
!begin
    ! 
    ME2=epsilon(1.0); SQME=ME2*ME2
    !  
    EE=Eps*Eps; if (EE<SQME) EE=SQME
    n=size(X); n1=n+1; Rmax=huge(0.0); CC=0
    allocate(S(1:n,1:n1), XH(n), XG(n),  &
      XL(n), XO(n), XR(n), XC(n), XE(n), F(n1))
    do i=1,n
        S(i,1)=X(i);
    enddo
    !     
    do j=2,n1
        do i=1,n
            if (j==(i+1)) then; S(i,j)=X(i)+H
                          else; S(i,j)=X(i)
            endif
        enddo
    enddo
    !  
    do j=1,n1
        do i=1,n; X(i)=S(i,j); enddo
        F(j)=Fun(X)
    enddo
620 continue
    !     
    !   
    FL=Rmax; FH=-Rmax
    do j=1,n1
        if (FL>F(j)) then; FL=F(j); jl=j; endif
        if (FH<F(j)) then; FH=F(j); jh=j; endif
    enddo
    !    
    !   
    FG=-Rmax
    do j=1,n1
        if ((j/=jh).and.(FG<F(j))) then; FG=F(j); jg=j; endif
    enddo
    !  XO, XL, XG, XH
    do i=1,n
        Sum1=0.0
        do j=1,n1
            if (j/=jh) Sum1=Sum1+S(i,j)
        enddo
        XO(i)=Sum1/float(n)
        XL(i)=S(i,jl); XG(i)=S(i,jg); XH(i)=S(i,jh)
    enddo
    do i=1,n; X(i)=XO(i); enddo
    Z=Fun(X); FO=Z   !; print *, 'To calculate the center of gravity in the line 1120'
    !     
    do i=1,n
        XR(i)=XO(i)+Alpha*(XO(i)-XH(i)); X(i)=XR(i)
    enddo
    Z=Fun(X); FR=Z   !; print *, 'To perform a reflection in the line 1220', Z
    ! FR<FL   
    if (FR<FL) goto 1300
    ! FR>FL  FR>FG   FR  FH
    !    XH  XR
    if (FR>FG) goto 1600
    goto 1520
1300 continue
    !  
    do i=1,n
        XE(i)=Gamma*XR(i)+(1.0-Gamma)*XO(i); X(i)=XE(i)
    enddo
    Z=Fun(X); FE=Z
    if (FE<FL) goto 1440
    goto 1520
1440 continue
    do i=1,n; S(i,jh)=XE(i); enddo
    F(jh)=FE   !; print *, 'To perform a reflection in the line 1480', Z
    !    2060
    goto 2060
1520 continue
    do i=1,n; S(i,jh)=XR(i); enddo
    F(jh)=FR   !; print *, 'To perform a reflection in the line 1560', Z
    goto 2060
1600 continue
    if (FR>FH) goto 1700
    do i=1,n; XH(i)=XR(i); enddo
    F(jh)=FR
1700 continue
    !  
    do i=1,n
        XC(i)=Beta*XH(i)+(1.0-Beta)*XO(i); X(i)=XC(i)
    enddo
    Z=Fun(X); FC=Z
    if (FC>FH) goto 1920
    do i=1,n; S(i,jh)=XC(i); enddo
    F(jh)=FC   !; print *, 'To perform a compression in the line 1880', Z
    goto 2060
1920 continue
    !   
    do j=1,n1
        do i=1,n
            S(i,j)=0.5*(S(i,j)+XL(i)); X(i)=S(i,j)
        enddo
        Z=Fun(X); F(j)=Z
    enddo   !; print *, 'To perform a reduction in the line 2040', Z
2060 continue
    !   
    Sum1=0.0; Sum2=0.0
    do j=1,n1
        Sum1=Sum1+F(j)
        Sum2=Sum2+F(j)*F(j)
    enddo
    Sigma=Sum2-Sum1*Sum1/float(n1); Sigma=Sigma/float(n1); CC=CC+1
    if ((CC<CCmax).and.(Sigma>=EE)) goto 620
    ! 
    do i=1,n; X(i)=XL(i); enddo
    print *, 'The minimum'
    print 33, (i, X(i), i=1,n)
    print *, 'The minimum of the function is', F(jl)
    print *, 'The number of iterations', CC
    deallocate(S, XH, XG, XL, XO, XR, XC, XE, F)
33  format(<n>(2X,'X[',I1,']=',F9.6))
end subroutine FM28
